The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::StkFrames Class Reference

An STK class to handle vectorized audio data. More...

`#include <Stk.h>`

## Public Member Functions
| StkFrames (unsigned int nFrames=0, unsigned int nChannels=0)
| The default constructor initializes the frame data structure to size zero.
| StkFrames (const StkFloat &value, unsigned int nFrames, unsigned int nChannels)
| Overloaded constructor that initializes the frame data to the specified size with `value`.
| ~StkFrames ()
| The destructor.
StkFloat & | operator[] (size_t n)
| Subscript operator that returns a reference to element `n` of self. More...
StkFloat | operator[] (size_t n) const
| Subscript operator that returns the value at element `n` of self. More...
StkFrames | operator+ (const StkFrames &frames) const
| Sum operator. More...
void | operator+= (StkFrames &f)
| Assignment by sum operator into self. More...
void | operator *= (StkFrames &f)
| Assignment by product operator into self. More...
StkFloat & | operator() (size_t frame, unsigned int channel)
| Channel / frame subscript operator that returns a reference. More...
StkFloat | operator() (size_t frame, unsigned int channel) const
| Channel / frame subscript operator that returns a value. More...
StkFloat | interpolate (StkFloat frame, unsigned int channel=0) const
| Return an interpolated value at the fractional frame index and channel. More...
size_t | size () const
| Returns the total number of audio samples represented by the object.
bool | empty () const
| Returns true if the object size is zero and false otherwise.
void | resize (size_t nFrames, unsigned int nChannels=1)
| Resize self to represent the specified number of channels and frames. More...
void | resize (size_t nFrames, unsigned int nChannels, StkFloat value)
| Resize self to represent the specified number of channels and frames and perform element initialization. More...
StkFrames & | getChannel (unsigned int channel, StkFrames &destinationFrames, unsigned int destinationChannel) const
| Retrieves a single channel. More...
void | setChannel (unsigned int channel, const StkFrames &sourceFrames, unsigned int sourceChannel)
| Sets a single channel. More...
unsigned int | channels (void) const
| Return the number of channels represented by the data.
unsigned int | frames (void) const
| Return the number of sample frames represented by the data.
void | setDataRate (StkFloat rate)
| Set the sample rate associated with the StkFrames data. More...
StkFloat | dataRate (void) const
| Return the sample rate associated with the StkFrames data. More...

## Detailed Description

An STK class to handle vectorized audio data.

This class can hold single- or multi-channel audio data. The data type is always StkFloat and the channel format is always interleaved. In an effort to maintain efficiency, no out-of-bounds checks are performed in this class unless STK_DEBUG is defined.

Internally, the data is stored in a one-dimensional C array. An indexing operator is available to set and retrieve data values. Alternately, one can use pointers to access the data, using the index operator to get an address for a particular location in the data:

StkFloat* ptr = &myStkFrames[0];

Note that this class can also be used as a table with interpolating lookup.

Possible future improvements in this class could include functions to convert to and return other data types.

by Perry R. Cook and Gary P. Scavone, 1995–2019.

## Member Function Documentation

## ◆ operator[]() [1/2]

StkFloat & stk::StkFrames::operator[] | ( | size_t | n | ) |
| inline

Subscript operator that returns a reference to element `n` of self.

The result can be used as an lvalue. This reference is valid until the resize function is called or the array is destroyed. The index `n` must be between 0 and size less one. No range checking is performed unless STK_DEBUG is defined.

441 {
442 #if defined(_STK_DEBUG_)
443 if ( n >= size_ ) {
444 std::ostringstream error;
445 error << "StkFrames::operator[]: invalid index (" << n << ") value!";
446 Stk::handleError( error.str(), StkError::MEMORY_ACCESS );
447 }
448 #endif
449
450 return data_[n];
451 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ operator[]() [2/2]

StkFloat stk::StkFrames::operator[] | ( | size_t | n | ) | const
| inline

Subscript operator that returns the value at element `n` of self.

The index `n` must be between 0 and size less one. No range checking is performed unless STK_DEBUG is defined.

454 {
455 #if defined(_STK_DEBUG_)
456 if ( n >= size_ ) {
457 std::ostringstream error;
458 error << "StkFrames::operator[]: invalid index (" << n << ") value!";
459 Stk::handleError( error.str(), StkError::MEMORY_ACCESS );
460 }
461 #endif
462
463 return data_[n];
464 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ operator+()

StkFrames stk::StkFrames::operator+ | ( | const StkFrames & | frames | ) | const
| inline

Sum operator.

The dimensions of the argument are expected to be the same as self. No range checking is performed unless STK_DEBUG is defined.

493 {
494 #if defined(_STK_DEBUG_)
495 if ( f.frames() != nFrames_ || f.channels() != nChannels_ ) {
496 std::ostringstream error;
497 error << "StkFrames::operator+: frames argument must be of equal dimensions!";
498 Stk::handleError( error.str(), StkError::MEMORY_ACCESS );
499 }
500 #endif
501 StkFrames sum((unsigned int)nFrames_,nChannels_);
502 StkFloat *sumPtr = &sum[0];
503 const StkFloat *fptr = f.data_;
504 const StkFloat *dPtr = data_;
505 for (unsigned int i = 0; i < size_; i++) {
506 *sumPtr++ = *fptr++ + *dPtr++;
507 }
508 return sum;
509 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.
stk::StkFrames::StkFrames
StkFrames(unsigned int nFrames=0, unsigned int nChannels=0)
The default constructor initializes the frame data structure to size zero.

## ◆ operator+=()

void stk::StkFrames::operator+= | ( | StkFrames & | f | ) |
| inline

Assignment by sum operator into self.

The dimensions of the argument are expected to be the same as self. No range checking is performed unless STK_DEBUG is defined.

512 {
513 #if defined(_STK_DEBUG_)
514 if ( f.frames() != nFrames_ || f.channels() != nChannels_ ) {
515 std::ostringstream error;
516 error << "StkFrames::operator+=: frames argument must be of equal dimensions!";
517 Stk::handleError( error.str(), StkError::MEMORY_ACCESS );
518 }
519 #endif
520
521 StkFloat *fptr = &f[0];
522 StkFloat *dptr = data_;
523 for ( unsigned int i=0; i<size_; i++ )
524 *dptr++ += *fptr++;
525 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ operator *=()

void stk::StkFrames::operator *= | ( | StkFrames & | f | ) |
| inline

Assignment by product operator into self.

The dimensions of the argument are expected to be the same as self. No range checking is performed unless STK_DEBUG is defined.

528 {
529 #if defined(_STK_DEBUG_)
530 if ( f.frames() != nFrames_ || f.channels() != nChannels_ ) {
531 std::ostringstream error;
532 error << "StkFrames::operator*=: frames argument must be of equal dimensions!";
533 Stk::handleError( error.str(), StkError::MEMORY_ACCESS );
534 }
535 #endif
536
537 StkFloat *fptr = &f[0];
538 StkFloat *dptr = data_;
539 for ( unsigned int i=0; i<size_; i++ )
540 *dptr++ *= *fptr++;
541 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ operator()() [1/2]

StkFloat & stk::StkFrames::operator() | ( | size_t | frame,
|  | unsigned int | channel
| ) |  |
| inline

Channel / frame subscript operator that returns a reference.

The result can be used as an lvalue. This reference is valid until the resize function is called or the array is destroyed. The `frame` index must be between 0 and frames() - 1. The `channel` index must be between 0 and channels() - 1. No range checking is performed unless STK_DEBUG is defined.

467 {
468 #if defined(_STK_DEBUG_)
469 if ( frame >= nFrames_ || channel >= nChannels_ ) {
470 std::ostringstream error;
471 error << "StkFrames::operator(): invalid frame (" << frame << ") or channel (" << channel << ") value!";
472 Stk::handleError( error.str(), StkError::MEMORY_ACCESS );
473 }
474 #endif
475
476 return data_[ frame * nChannels_ + channel ];
477 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ operator()() [2/2]

StkFloat stk::StkFrames::operator() | ( | size_t | frame,
|  | unsigned int | channel
| ) |  | const
| inline

Channel / frame subscript operator that returns a value.

The `frame` index must be between 0 and frames() - 1. The `channel` index must be between 0 and channels() - 1. No range checking is performed unless STK_DEBUG is defined.

480 {
481 #if defined(_STK_DEBUG_)
482 if ( frame >= nFrames_ || channel >= nChannels_ ) {
483 std::ostringstream error;
484 error << "StkFrames::operator(): invalid frame (" << frame << ") or channel (" << channel << ") value!";
485 Stk::handleError( error.str(), StkError::MEMORY_ACCESS );
486 }
487 #endif
488
489 return data_[ frame * nChannels_ + channel ];
490 }
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ interpolate()

StkFloat stk::StkFrames::interpolate | ( | StkFloat | frame,
|  | unsigned int | channel = `0`
| ) |  | const

Return an interpolated value at the fractional frame index and channel.

This function performs linear interpolation. The `frame` index must be between 0.0 and frames() - 1. The `channel` index must be between 0 and channels() - 1. No range checking is performed unless STK_DEBUG is defined.

## ◆ resize() [1/2]

void stk::StkFrames::resize | ( | size_t | nFrames,
|  | unsigned int | nChannels = `1`
| ) |  |

Resize self to represent the specified number of channels and frames.

Changes the size of self based on the number of frames and channels. No element assignment is performed. No memory deallocation occurs if the new size is smaller than the previous size. Further, no new memory is allocated when the new size is smaller or equal to a previously allocated size.

## ◆ resize() [2/2]

void stk::StkFrames::resize | ( | size_t | nFrames,
|  | unsigned int | nChannels,
|  | StkFloat | value
| ) |  |

Resize self to represent the specified number of channels and frames and perform element initialization.

Changes the size of self based on the number of frames and channels, and assigns `value` to every element. No memory deallocation occurs if the new size is smaller than the previous size. Further, no new memory is allocated when the new size is smaller or equal to a previously allocated size.

## ◆ getChannel()

StkFrames& stk::StkFrames::getChannel | ( | unsigned int | channel,
|  | StkFrames & | destinationFrames,
|  | unsigned int | destinationChannel
| ) |  | const

Retrieves a single channel.

Copies the specified `channel` into `destinationFrames's` `destinationChannel`. `destinationChannel` must be between 0 and destination.channels() - 1 and `channel` must be between 0 and channels() - 1. destination.frames() must be >= frames(). No range checking is performed unless STK_DEBUG is defined.

## ◆ setChannel()

void stk::StkFrames::setChannel | ( | unsigned int | channel,
|  | const StkFrames & | sourceFrames,
|  | unsigned int | sourceChannel
| ) |  |

Sets a single channel.

Copies the `sourceChannel` of `sourceFrames` into the `channel` of self. SourceFrames.frames() must be equal to frames(). No range checking is performed unless STK_DEBUG is defined.

## ◆ setDataRate()

void stk::StkFrames::setDataRate | ( | StkFloat | rate | ) |
| inline

Set the sample rate associated with the StkFrames data.

By default, this value is set equal to the current STK sample rate at the time of instantiation.

414 { dataRate_ = rate; };

## ◆ dataRate()

StkFloat stk::StkFrames::dataRate | ( | void |  | ) | const
| inline

Return the sample rate associated with the StkFrames data.

By default, this value is set equal to the current STK sample rate at the time of instantiation.

421 { return dataRate_; };

The documentation for this class was generated from the following file:

- Stk.h

The Synthesis ToolKit in C++ (STK)
©1995--2019 Perry R. Cook and Gary P. Scavone. All Rights Reserved.